;;;
;;; $Header: /home/gene/icfp2001/source/RCS/totoro.lisp,v 1.5 2001/07/29 09:17:35 gene Exp $
;;;

(load "source/a.lisp")

(defvar *meaning* nil
  "Holds the \"meaning\" of the single input we parse from stdin.")

(defun totoro (seconds-to-run pool-size)
  (let ((stop-time (+ seconds-to-run (get-universal-time))))
    (setq *meaning* (sml-parse))
    (evolver-init pool-size)
    (do ((start (get-universal-time))
	 (stop (get-universal-time))
	 (duration 0))
	((>= (+ duration (get-universal-time)) stop-time))

	(setq start (get-universal-time))
	(evolve)
	(setq stop (get-universal-time))
	(setq duration (max 1 (- stop start)))
	(when *debug* (format t "~&totoro: debug: duration is ~A" duration)))))

;; (trace action-ensure)
;; (trace evolver-init evolve)
;; (trace make-random-organism)
;; (trace sml-print ensure-context ensure-context-push ensure-context-pop)

;; (setq *debug* t)
(let ((strm (make-string-input-stream (car *args*))))
  (totoro (read strm) 32))

;;; --- end of file ---
